<template>
	<mind-form v-model="formViaje" title="Viaje" :small="embedded" footer
		@submit="onSubmitViaje" hide-buttons :rules="rules"
		>
			<template v-slot="{form}">
				<el-row>
					<el-col :md="18">
						<el-divider content-position="left">Origen</el-divider>
						<el-form-item label="Calle/Lugar">
							<el-col  :lg="18" >
								<el-form-item  prop="origenCalle">
									<select-lugar calles lugares frecuentes placeholder="Calle" v-model="formViaje.origenCalle" lazy @select="actualizarLocalidadOrigen" />
								</el-form-item>
							</el-col>
							<el-col :lg="6" >
								<el-input v-model="form.origenNumero" 
									placeholder="Número" 
									:disabled="form.tipoOrigen != 'Calle'"
									@change="buscarCliente(form.origenCalle, form.origenNumero)" />
							</el-col>
						</el-form-item>
						<el-form-item  label="Entre" >
							<template >
								<el-col  :lg="12"  >
									<select-lugar calles 
										placeholder="Calle 1" 
										v-model="form.origenCalle1" 
										:disabled="form.tipoOrigen != 'Calle'"
										lazy  
									/>
								</el-col>
								<el-col :lg="12">
									<select-lugar 
										calles placeholder="Calle 2" 
										v-model="form.origenCalle2" lazy  
										:disabled="form.tipoOrigen != 'Calle'"
										/>
								</el-col>
							</template>
						</el-form-item>
						<!-- <el-col  :lg="24" > -->
							<el-form-item prop="origenLocalidad" label="Localidad" >
								<el-input v-model="form.origenLocalidad" placeholder="Localidad"/>
							</el-form-item>
						<!-- </el-col> -->
						<el-divider content-position="left">Destino</el-divider>
						<el-form-item label="Lugar/Calle">
							<el-col  :lg="18" >
								<el-form-item  prop="destinoCalle">
									<select-lugar calles lugares frecuentes placeholder="Destino" v-model="formViaje.destinoCalle" lazy @select="actualizarLocalidadDestino" />
								</el-form-item>
							</el-col>
								<el-col :lg="6" >
									<el-input v-model="form.destinoNumero" 
										placeholder="Número" 
										:disabled="form.tipoDestino != 'Calle'"
									/>
								</el-col>
						</el-form-item>
						<el-form-item prop="destinoLocalidad" label="Localidad"> 
							<el-input v-model="form.destinoLocalidad" placeholder="Localidad"/>
						</el-form-item>

						<el-divider content-position="left">Reserva</el-divider>
						<el-form-item  label="Fecha">
							<el-col  :lg="12" >
								<el-date-picker
									v-model="form.fecha"
									value-format="yyyy-MM-dd"
									type="date"
									placeholder="Fecha">
								</el-date-picker>
							</el-col>
							<el-col  :lg="12" >
								<el-time-select
									v-model="form.hora"
									:picker-options="{
										start: '00:00',
										step: '00:15',
										end: '23:45'
									}"
									placeholder="Hora">
								</el-time-select>
							</el-col>
							<el-col  :lg="12" >
								<el-form-item >
									<el-input type="number" v-model.number="form.anticipacionReserva" 
										placeholder="Aviso" prefix-icon="el-icon-alarm-clock">
										<!-- <span slot="prepend">Anticipación</span> -->
										<span slot="append">minutos</span>
									</el-input>
								</el-form-item>
							</el-col>
						</el-form-item>
						<el-divider content-position="left"></el-divider>
						<el-form-item label="Notas" >
							<el-input
								type="textarea"
								:rows="2"
								placeholder="Notas"
								v-model="form.obs">
							</el-input>
						</el-form-item>
						<el-row>
							<el-col  :lg="12" >
								<el-form-item  label="Estado">
								{{form.estado}}
								</el-form-item>
							</el-col>
						</el-row>
					</el-col>
					<el-col :md="6">
						<el-form-item label="Cliente" >
								<select-cliente :disabled="!!formViaje.id" clearable v-model="formViaje.idCliente" @change="fetchCliente"/>
						</el-form-item>
						<el-card class="card-cliente">
							<div slot="header" >
								<b>Datos Cliente</b>
							</div>
							<div v-if="datosCliente.id" class="text item">
								<b class="text-label">Nombre</b>
								<span class="text-item" >
									{{datosCliente.nombre}}
								</span>
								<b class="text-label">Dirección</b>
								<span class="text-item" >
									{{datosCliente.calle}} {{datosCliente.numero}}
								</span>
								<b class="text-label">Notas</b>
								<span class="text-item" >
									<span style="white-space: pre-line">{{datosCliente.obs}}</span>
								</span>
									<!-- {{datosCliente}} -->
							</div>
						</el-card>
					</el-col>
				</el-row>
			</template>
			<template  v-slot:footer="{form, submit}" >
				<el-button type="danger" v-if="esAnulable" @click="anularViaje(form)">Anular Viaje</el-button>
				<el-button type="primary" @click="submit()">Aplicar</el-button>
			</template>
	</mind-form>
</template>
<script>
import store from '@/store/viajes'
// import storeLugares from '@/store/lugares'
// import storeCientes from '@/store/clientes'
import {Rest, Rules} from '@/../modules/mind-core-vue/'
import selectLugar from '@/components/select-lugar'
import selectCliente from '@/components/select-cliente'
export default {
	components:{
		selectLugar,
		selectCliente,
	},
	props: {
		idViaje: Number,
		embedded: Boolean,
	},
	created() {

		this.apiClientes = new Rest({
			uri: `api/agencias/${store.idAgencia}/clientes`, 
			key: 'id'})

	},	computed: {
		esAnulable() {
			return this.formViaje.id && (this.formViaje.estado == 'Pendiente' || this.formViaje.estado == 'En Curso')
		},

	},

	methods: {

		/**
		 * Obtiene los datos del viaje seleccionado
		 * @param id id de viaje
		 */
		async fetchViaje(id) {
			this.formViaje = await this.api.Fetch(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});				
			})
			this.fetchCliente(this.formViaje.idCliente)
			// this.formViaje = planilla
		},

		nuevoViaje() {
			this.formViaje = {
				tipoOrigen: 'Calle',
				tipoDestino: 'Lugar',
				origenCalle: '',
				origenCalle1: null,
				origenCalle2: null,
				destinoCalle: '',
				origenLocalidad: null,
				destinoLocalidad: null,
				idCliente: null,
			}
		},

		onCancel() {
			this.$emit('cancel')
		},

		/**
		 * Actualiza/crea viaje
		 * @param viaje datos del viaje
		 */
		async onSubmitViaje(viaje) {
			let result, msg ;
			if(viaje.id) { //viaje Existente
				await this.api.Patch(viaje)
				.then(()=>{
					result = 'success'
					msg = 'Viaje actualizado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			} else { //viaje nuevo
				await this.api.Post(viaje)
				.then(()=>{
					result = 'success'
					msg = 'Viaje cargado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			}
			this.$message({
				type: result,
				showClose: result == 'error',
				message: msg
			});
			this.$emit('submit')
		},

		anularViaje(viaje) {
			this.$confirm('Confirma la Anulación del Viaje?', 'Anular Viaje', {
					confirmButtonText: 'Si',
					cancelButtonText: 'No',
					type: 'warning'
				}).then(async () => {
					await this.api.Delete(viaje)
					.then(()=>{
						this.$message({
							showClose: true,
							type: 'warning',
							message: "Se Anuló el Viaje"
						});
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						});
					})
				})
			this.$emit('submit')
		},

		async fetchLugares() {
			this.apiLugares.FetchAll({
				filters: {
				},
				sort: ['tipo','nombre']
			}).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},

		async fetchCliente(id) {
			if(!id) {
				this.datosCliente = {}
				return
			}
			this.datosCliente = await this.apiClientes.Fetch(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});				
			})

		},

		async buscarCliente(calle, numero) {
			if(this.datosCliente.id) {
				return
			}
			if(!calle || !numero) {
				this.datosCliente = {}
				return
			}
			let clientes = await this.apiClientes.FetchAll({
				filters: {
					calle: calle,
					numero: numero,
				},
			}).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
			// if(clientes.length > 0) {
				this.datosCliente =  clientes.length > 0 ? clientes[0]:{}
			if(this.datosCliente.id) {
				this.formViaje.origenCalle1 = this.datosCliente.calle1
				this.formViaje.origenCalle2 = this.datosCliente.calle2
				this.formViaje.idCliente = this.datosCliente.id
			}
			// }
		},
		actualizarLocalidadOrigen(v) {
			console.log(v)
			this.formViaje.tipoOrigen = v.tipo
			this.formViaje.origenLocalidad = v.localidad
		},
		actualizarLocalidadDestino(v) {
			this.formViaje.tipoDestino = v.tipo
			this.formViaje.destinoLocalidad = v.localidad
		}


	},
	watch: {
		idViaje: {
			immediate: true,
			handler(v) {
				this.api = this.api || new Rest({
					uri: `api/agencias/${store.idAgencia}/viajes`, 
					state: store.data,
					key: 'id'})
				if(v) {
						this.fetchViaje(v)
						} else {
						this.nuevoViaje()
					}
			}
		}
	},
	data() {
		return {
			formViaje: {
			},
			rules: {
				origenCalle:[
					Rules.required,
				],
				destinoCalle:[
					Rules.required,
				],
				destinoLocalidad:[
					Rules.required,
				],
				origenLocalidad:[
					Rules.required,
				],
			},
			api: null,
			apiLugares: null,
			apiClientes: null,
			origenManual: false,
			destinoManual: false,
			datosCliente: {},
		}
	}

}
</script>
<style scoped>
.el-divider {
	margin: 10px 0px;
}

.select-prepend {
	width: 90px;
}
.card-cliente {
 margin-left: 10px;
}

.text-label {
	width:100%;
	display:inline-block;
}
.text-item {
	margin-left: 10px;
	width:100%;
	display:inline-block;
}
</style>
<style>
.el-select,
.el-autocomplete {
	width: 100%;
}
</style>
